unit uFenster;
// **********************************************************************
(* K L A S S E :  FENSTER                                               *)
(* -------------------------------------------------------------------- *)
(* Version     :  1.1                                                   *)
(* Autor       :  (c) Siegfried Spolwig, OSZ Handel, 10997              *)
(*                                                                      *)
(* Aufgabe     : Veranschaulichung des Datenflusses bei M-V-C           *)
(* Compiler    : DELPHI 5.0                                             *)
(* Aenderung   : V. 1.0 - 28-AUG-98																			*)
(*             :    1.1	-	22-AUG-01		Tperson	                          *)
// **********************************************************************

interface
// ======================================================================
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons,
  uPerson, ComCtrls;

type
  TFensterFrm = class(TForm)
    OKBtn         : TButton;
    AnzeigeBtn    : TSpeedButton;
    Splitter1	    : TSplitter;
    SetGrLbl	    : TLabel;
    GetGrLbl	    : TLabel;
    SetGwLbl	    : TLabel;
    GetGwLbl	    : TLabel;
    HatBmiLbl	    : TLabel;
    SetNameLbl    : TLabel;
    GetnameLbl    : TLabel;
    EssLbl		    : TLabel;
    ObjPnl0       : TPanel;
    ModelPnl      : TPanel;
    ObjektLbl     : TLabel;
    ONameLbl      : TLabel;
    OGroesseLbl   : TLabel;
    Label7        : TLabel;
    OSetLbl       : TLabel;
    OGetLbl       : TLabel;
    OSchlemLbl    : TLabel;
    OHatLbl       : TLabel;
    StrichLabel3  : TLabel;
    Strich2Label  : TLabel;
    ModelLbl      : TLabel;
    VCLbl         : TLabel;
    ONameWLbl     : TLabel;
    OGrWLbl       : TLabel;
    OGewWLbl      : TLabel;
    Panel1: TPanel;
    Label5: TLabel;
    NaLbl: TLabel;
    NameEdt: TEdit;
    Label1: TLabel;
    GroesseEdt: TEdit;
    GroesseLbl: TLabel;
    Label2: TLabel;
    GewichtEdt: TEdit;
    GewichtLbl: TLabel;
    EssBtnLbl: TLabel;
    EsBtn: TButton;
    BMI2Lbl: TLabel;
    BmiPnl: TPanel;
    BMILbl: TLabel;

    procedure OKBtnClick (Sender: TObject);      // --- hier die EREIGNISPROZEDUREN
    procedure AnzeigeBtnClick (Sender: TObject);
    procedure FormCreate (Sender: TObject);
    procedure EsBtnClick (Sender: TObject);
    procedure GroesseEdtKeyPress (Sender: TObject; var Key: Char);
    procedure NameEdtKeyPress(Sender: TObject; var Key: Char);
    procedure GewichtEdtKeyPress(Sender: TObject; var Key: Char);

   private
    procedure Init;
    procedure DatenAktualisieren(var Pers : TPerson);  // -- hier der Datentransport
    procedure MaskeAktualisieren(Pers : TPerson);
    procedure ModelAnzeigeAktualisieren;
   public
  end;

var
  FensterFrm: TFensterFrm;   // --- das aktuelle Exemplar vom Fenster, in dem alles luft


implementation
{$R *.DFM}
// ======================================================================
var
  AktuellePerson : TPerson;


procedure TFensterFrm.FormCreate(Sender: TObject);
// ----------------------------------------------------------------------
begin
  AktuellePerson := TPerson.Create;
  AktuellePerson.Init;
  FensterFrm.Init;
  ModelAnzeigeAktualisieren;
  SetNameLbl.Enabled := false;
  GetNameLbl.Enabled := false;
  SetGrLbl.Enabled	:= false;
  GetGrLbl.Enabled 	:= false;
  SetGwLbl.Enabled 	:= false;
  GetGwLbl.Enabled 	:= false;
  HatBmiLbl.Enabled := false;
  EssLbl.Enabled		:= false;
end;

procedure TFensterFrm.Init;
// ----------------------------------------------------------------------
begin
	NameEdt.Text 	  := '';
  GroesseEdt.Text := '';
  GewichtEdt.Text := '';
end; 

		            // --- hier luft der DATENTRANSPORT -------

procedure TFensterFrm.DatenAktualisieren(var Pers : TPerson);
// ----------------------------------------------------------------------
begin
	Pers.SetName (NameEdt.Text);
  Pers.SetGroesse (StrToFloat (GroesseEdt.Text));
  Pers.SetGewicht (StrToFloat (GewichtEdt.Text));
end;


procedure TFensterFrm.MaskeAktualisieren(Pers : TPerson);
// ----------------------------------------------------------------------
begin
  NameEdt.Text 		:= Pers.GetName;
  GroesseEdt.Text := FloatToStr (Pers.GetGroesse);
  GewichtEdt.Text := FloatToStr (Pers.GetGewicht);
  BmiPnl.Caption	:= FloatToStr (Pers.HatBMI);
end;


// *** diese Procedure gehoert im engeren Sinne nicht zur GUI<-->PERSON
// *** Architektur, sondern dient zustzlich zur Anzeige hier im Model-Objekt

procedure TFensterFrm.ModelAnzeigeAktualisieren;
// ----------------------------------------------------------------------
begin
 ONameWLbl.Caption :=(AktuellePerson.GetName);
 OGrWLbl.Caption   :=	 Floattostr(AktuellePerson.GetGroesse);
 OGewWLbl.Caption := Floattostr(AktuellePerson.GetGewicht);
end;

      // --- hier beginnen die EREIGNISPROZEDUREN zur STEUERUNG (Control)

procedure TFensterFrm.OKBtnClick(Sender: TObject);
// ----------------------------------------------------------------------
begin
	SetNameLbl.Enabled := true;
  SetGrLbl.Enabled 	 := true;
  SetGwLbl.Enabled 	 := true;
  GetNameLbl.Enabled := false;
  GetGrLbl.Enabled 	 := false;
  GetGwLbl.Enabled 	 := false;
  HatBmiLbl.Enabled  := false;

  DatenAktualisieren(AktuellePerson);
  Init;
  ModelAnzeigeAktualisieren;
end;


procedure TFensterFrm.AnzeigeBtnClick(Sender: TObject);
// ----------------------------------------------------------------------
begin
  GetNameLbl.Enabled 	:= true;
  GetGrLbl.Enabled	 	:= true;
  GetGwLbl.Enabled 		:= true;
  HatBmiLbl.Enabled 	:= true;
  SetNameLbl.Enabled 	:= false;
  SetGrLbl.Enabled		:= false;
  SetGwLbl.Enabled 		:= false;
  EssLbl.Enabled			:= false;

  NameEdt.Font.Color 		:= clBlue;
  GroesseEdt.Font.Color := clBlue;
  GewichtEdt.Font.Color := clBlue;

  MaskeAktualisieren(AktuellePerson);
  BmiPnl.Font.Color 		:= clBlue;
  if AktuellePerson.HatBmi < 19
  then BmiPnl.Color := RGB(238,238,188)
  else
  	if AktuellePerson.HatBmi > 24
    then BmiPnl.Color := RGB(255,70,0)
    else BmiPnl.Color := RGB(200,250,200);
end;

procedure TFensterFrm.EsBtnClick(Sender: TObject);
// ----------------------------------------------------------------------
begin
  EssLbl.Enabled 		 := true;	
	SetNameLbl.Enabled := false;
  GetNameLbl.Enabled := false;
  SetGrLbl.Enabled	 := false;
  GetGrLbl.Enabled	 := false;
  SetGwLbl.Enabled	 := false;
  GetGwLbl.Enabled	 := false;
  HatBmiLbl.Enabled	 := false;

  AktuellePerson.Schlemmen;
  ModelAnzeigeAktualisieren;
end;

procedure TFensterFrm.GroesseEdtKeyPress(Sender: TObject; var Key: Char);
// ----------------------------------------------------------------------
begin
  GroesseEdt.Font.Color := clBlack;
end;

procedure TFensterFrm.NameEdtKeyPress(Sender: TObject; var Key: Char);
// ----------------------------------------------------------------------
begin
  NameEdt.Font.Color := clBlack;
end;

procedure TFensterFrm.GewichtEdtKeyPress(Sender: TObject; var Key: Char);
// ----------------------------------------------------------------------
begin
  GewichtEdt.Font.Color := clBlack;
end;



end. // ------ UNIT -------
